#include <Application.h>
#include <iostream.h>
#include <stdio.h>
#include <StatusBar.h>
#include <TextControl.h>
#include <RadioButton.h>
#include <StringView.h>
#include <CheckBox.h>
#include <Button.h>
#include <Box.h>
#include <Alert.h>
#include "cameraprops.h"
#include "debug.h"

const rgb_color BKG_GREY		= { 216, 216, 216, 0 };

cameraprops::cameraprops(BRect rect, BSerialPort* theport) : BWindow(rect, "Camera Properties", B_MODAL_WINDOW,	B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_WILL_DRAW)
{
	ComPort = theport;
	updateCameraStatusInfo();
	propsview = new BView(BRect(0,0,500,550), "Properties View", B_FOLLOW_ALL_SIDES, B_WILL_DRAW);
	propsview->SetViewColor(BKG_GREY);
	AddChild(propsview);

	BBox *box_L1S1 = new BBox(BRect(10, 10, 358, 154), "name", B_FOLLOW_LEFT | B_FOLLOW_TOP, B_FRAME_EVENTS | B_NAVIGABLE_JUMP | B_WILL_DRAW, B_FANCY_BORDER);
	box_L1S1->SetLabel("Memory Card");
	propsview->AddChild(box_L1S1);
	
	BTextControl *textControl_L2S2 = new BTextControl(BRect(10, 14, 341, 34), "name", "Memory Card ID :", &cardid[0], 0/*insert BMessage object here*/, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	textControl_L2S2->SetEnabled(false);
	textControl_L2S2->SetFont(be_plain_font);
	textControl_L2S2->SetFontSize(12);
	textControl_L2S2->SetDivider(105);
	box_L1S1->AddChild(textControl_L2S2);

	
	BCheckBox *checkBox_L2S3 = new BCheckBox(BRect(17, 78, 165, 100), "name", "Card Formatted", 0, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	checkBox_L2S3->SetEnabled(false);
	box_L1S1->AddChild(checkBox_L2S3);

	BCheckBox *checkBox_L2S4 = new BCheckBox(BRect(17, 108, 164, 130), "name", "Card Write Protected", 0, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	checkBox_L2S4->SetEnabled(false);
	box_L1S1->AddChild(checkBox_L2S4);

	BCheckBox *checkBox_L2S5 = new BCheckBox(BRect(17, 48, 165, 70), "name", "Memory Card Inserted", 0, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	checkBox_L2S5->SetEnabled(false);
	box_L1S1->AddChild(checkBox_L2S5);

	BButton *button_L2S6 = new BButton(BRect(209, 50, 319, 80), "name", "Erase All Images", new BMessage(B_ERASEALL), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	box_L1S1->AddChild(button_L2S6);

	BButton *button_L2S7 = new BButton(BRect(209, 90, 319, 120), "name", "Format Card", new BMessage(B_FORMATCARD), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	button_L2S7->SetEnabled(false);
	box_L1S1->AddChild(button_L2S7);

	BBox *box_L1S8 = new BBox(BRect(10, 160, 358, 416), "name", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_FRAME_EVENTS|B_NAVIGABLE_JUMP|B_WILL_DRAW, B_FANCY_BORDER);
	box_L1S8->SetLabel("Camera");
	propsview->AddChild(box_L1S8);

	BTextControl *textControl_L2S9 = new BTextControl(BRect(14, 18, 337, 38), "name", "Camera ID :", &cameraid[0], 0/*insert BMessage object here*/, B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	textControl_L2S9->SetEnabled(false);
	textControl_L2S9->SetFont(be_plain_font);
	textControl_L2S9->SetFontSize(12);
	textControl_L2S9->SetDivider(74);
	box_L1S8->AddChild(textControl_L2S9);

	BStringView *stringView_L2S10 = new BStringView(BRect(13, 51, 101, 69), "name", "Zoom Position", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	box_L1S8->AddChild(stringView_L2S10);
		
	BView *radioButtonView_L2S11 = new BView(BRect(13, 78, 110, 217), "name", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButton_L2S111 = new BRadioButton(BRect(0, 0, 97, 0), "", "58 mm", new BMessage(B_ZOOM58), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S11->AddChild(radioButton_L2S111);
	radioButton_L2S112 = new BRadioButton(BRect(0, 23, 97, 24), "", "51 mm", new BMessage(B_ZOOM51), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S11->AddChild(radioButton_L2S112);
	radioButton_L2S113 = new BRadioButton(BRect(0, 46, 97, 48), "", "41 mm", new BMessage(B_ZOOM41), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S11->AddChild(radioButton_L2S113);
	radioButton_L2S114 = new BRadioButton(BRect(0, 69, 97, 72), "", "34 mm", new BMessage(B_ZOOM34), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S11->AddChild(radioButton_L2S114);
	radioButton_L2S115 = new BRadioButton(BRect(0, 92, 97, 96), "", "29 mm", new BMessage(B_ZOOM29), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S11->AddChild(radioButton_L2S115);
	radioButton_L2S116 = new BRadioButton(BRect(0, 115, 97, 120), "", "Close Up", new BMessage(B_ZOOMCL), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S11->AddChild(radioButton_L2S116);
	radioButtonView_L2S11->SetViewColor(BKG_GREY);
	box_L1S8->AddChild(radioButtonView_L2S11);

	BStringView *stringView_L2S12 = new BStringView(BRect(116, 51, 191, 71), "name", "Flash Mode", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	box_L1S8->AddChild(stringView_L2S12);

	BStringView *stringView_L2S13 = new BStringView(BRect(244, 50, 328, 70), "name", "Image Quality", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	box_L1S8->AddChild(stringView_L2S13);

	BView *radioButtonView_L2S14 = new BView(BRect(244, 77, 340, 137), "name", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButton_L2S141 = new BRadioButton(BRect(0, 0, 95, 0), "", "Good", new BMessage(B_QUALGOOD), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S14->AddChild(radioButton_L2S141);
	radioButton_L2S142 = new BRadioButton(BRect(0, 19, 95, 20), "", "Better", new BMessage(B_QUALBETTER), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S14->AddChild(radioButton_L2S142);
	radioButton_L2S143 = new BRadioButton(BRect(0, 38, 95, 40), "", "Best", new BMessage(B_QUALBEST), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S14->AddChild(radioButton_L2S143);
	radioButtonView_L2S14->SetViewColor(BKG_GREY);
	box_L1S8->AddChild(radioButtonView_L2S14);

	BView *radioButtonView_L2S15 = new BView(BRect(116, 77, 234, 176), "name", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButton_L2S151 = new BRadioButton(BRect(0, 0, 117, 0), "", "Automatic", new BMessage(B_FLASHAUTO), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S15->AddChild(radioButton_L2S151);
	radioButton_L2S152 = new BRadioButton(BRect(0, 19, 117, 20), "", "On", new BMessage(B_FLASHON), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S15->AddChild(radioButton_L2S152);
	radioButton_L2S153 = new BRadioButton(BRect(0, 38, 117, 40), "", "Off", new BMessage(B_FLASHOFF), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S15->AddChild(radioButton_L2S153);
	radioButton_L2S154 = new BRadioButton(BRect(0, 57, 117, 60), "", "Auto Fill Red Eye", new BMessage(B_FLASHAUTOFILL), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S15->AddChild(radioButton_L2S154);
	radioButton_L2S155 = new BRadioButton(BRect(0, 76, 117, 80), "", "Fill Red Eye", new BMessage(B_FLASHFILL), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S15->AddChild(radioButton_L2S155);
	radioButtonView_L2S15->SetViewColor(BKG_GREY);
	box_L1S8->AddChild(radioButtonView_L2S15);

	BStringView *stringView_L2S16 = new BStringView(BRect(116, 184, 208, 201), "name", "Image Format", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	box_L1S8->AddChild(stringView_L2S16);

	BView *radioButtonView_L2S17 = new BView(BRect(116, 207, 233, 245), "name", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButton_L2S171 = new BRadioButton(BRect(0, 0, 117, 0), "", "JPEG", new BMessage(B_JPEGPIC), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S17->AddChild(radioButton_L2S171);
	radioButton_L2S172 = new BRadioButton(BRect(0, 19, 117, 20), "", "FlashPIX", new BMessage(B_FPIXPIC), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S17->AddChild(radioButton_L2S172);
	radioButtonView_L2S17->SetViewColor(BKG_GREY);
	box_L1S8->AddChild(radioButtonView_L2S17);

	checkBox_L2S18 = new BCheckBox(BRect(13, 226, 109, 246), "name", "Timer Mode", new BMessage(B_DELAYTIMER), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	box_L1S8->AddChild(checkBox_L2S18);

	BView *radioButtonView_L2S19 = new BView(BRect(244, 168, 334, 208), "name", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButton_L2S191 = new BRadioButton(BRect(0, 0, 86, 0), "", "640 x 480", new BMessage(B_LOWRESPIC), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S19->AddChild(radioButton_L2S191);
	radioButton_L2S192 = new BRadioButton(BRect(0, 20, 86, 21), "", "1152x864", new BMessage(B_HIRESPIC), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	radioButtonView_L2S19->AddChild(radioButton_L2S192);
	radioButtonView_L2S19->SetViewColor(BKG_GREY);
	box_L1S8->AddChild(radioButtonView_L2S19);
	BStringView *stringView_L2S20 = new BStringView(BRect(244, 142, 317, 162), "name", "Resolution", B_FOLLOW_LEFT|B_FOLLOW_TOP, B_WILL_DRAW);
	box_L1S8->AddChild(stringView_L2S20);
	BButton *button_L1S211 = new BButton(BRect(234, 208, 324, 243), "name", "Set Camera Time", new BMessage(B_SETCAMTIME), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	box_L1S8->AddChild(button_L1S211);


	BButton *button_L1S22 = new BButton(BRect(120, 423, 210, 458), "name", "OK", new BMessage(B_CANCELPROPSWINDOW), B_FOLLOW_LEFT|B_FOLLOW_TOP, B_NAVIGABLE|B_WILL_DRAW);
	propsview->AddChild(button_L1S22);

	switch(zoomposition) 
	{
		case Z_58MM:
		{
		radioButton_L2S111->SetValue(1);
		break;
		}
		case Z_51MM:
		{
		radioButton_L2S112->SetValue(1);
		break;
		}
		case Z_41MM:
		{
		radioButton_L2S113->SetValue(1);
		break;
		}
		case Z_34MM:
		{
		radioButton_L2S114->SetValue(1);
		break;
		}
		case Z_29MM:
		{
		radioButton_L2S115->SetValue(1);
		break;
		}
		case Z_CLOSEUP:
		{
		radioButton_L2S116->SetValue(1);
		break;
		}
	}
	switch(flashsetting) 
	{
		case F_AUTO:
		{
		radioButton_L2S151->SetValue(1);
		break;
		}
		case F_FILL:
		{
		radioButton_L2S152->SetValue(1);
		break;
		}
		case F_OFF:
		{
		radioButton_L2S153->SetValue(1);
		break;
		}
		case F_AUTORED:
		{
		radioButton_L2S154->SetValue(1);
		break;
		}
		case F_FILLRED:
		{
		radioButton_L2S155->SetValue(1);
		break;
		}
	}
	switch(cameraresolution) 
	{
		case LOW_RES:
		{
		radioButton_L2S191->SetValue(1);
		break;
		}
		case HI_RES:
		{
		radioButton_L2S192->SetValue(1);
		break;
		}
	}
	switch(camerafiletype) 
	{
		case JPEG:
		{
		radioButton_L2S171->SetValue(1);
		break;
		}
		case FPIX:
		{
		radioButton_L2S172->SetValue(1);
		break;
		}
	}
	switch(quality) 
	{
		case Q_GOOD:
		{
		radioButton_L2S141->SetValue(1);
		break;
		}
		case Q_BETTER:
		{
		radioButton_L2S142->SetValue(1);
		break;
		}
		case Q_BEST:
		{
		radioButton_L2S143->SetValue(1);
		break;
		}
	}
	if (timermode) 
		checkBox_L2S18->SetValue(1);
	else
		checkBox_L2S18->SetValue(0);
	if (!cardillegal) 
		checkBox_L2S5->SetValue(1);
	else
		checkBox_L2S5->SetValue(0);
	if (cardwriteprotect) 
		checkBox_L2S4->SetValue(1);
	else
		checkBox_L2S4->SetValue(0);
	if (cardformatted) 
		checkBox_L2S3->SetValue(1);
	else
		checkBox_L2S3->SetValue(0);
}

bool
cameraprops::QuitRequested()
{
	return(true);
}

void
cameraprops::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		case B_CANCELPROPSWINDOW:
		{
			Quit();
			break;
		}
		case B_ZOOM58:
		{
 			setZoom(Z_58MM);
			break;
		}
		case B_ZOOM51:
		{
 			setZoom(Z_51MM);
			break;
		}
		case B_ZOOM41:
		{
 			setZoom(Z_41MM);
			break;
		}
		case B_ZOOM34:
		{
 			setZoom(Z_34MM);
			break;
		}
		case B_ZOOM29:
		{
 			setZoom(Z_29MM);
			break;
		}
		case B_ZOOMCL:
		{
 			setZoom(Z_CLOSEUP);
			break;
		}
		case B_FLASHAUTO:
		{
 			setFlashMode(F_AUTO);
			break;
		}
		case B_FLASHON:
		{
 			setFlashMode(F_FILL);
			break;
		}
		case B_FLASHOFF:
		{
 			setFlashMode(F_OFF);
			break;
		}
		case B_FLASHAUTOFILL:
		{
 			setFlashMode(F_AUTORED);
			break;
		}
		case B_FLASHFILL:
		{
 			setFlashMode(F_FILLRED);
			break;
		}
		case B_LOWRESPIC:
		{
 			setResolution(LOW_RES);
			break;
		}
		case B_HIRESPIC:
		{
 			setResolution(HI_RES);
			break;
		}
		case B_JPEGPIC:
		{
 			setFileFormat(JPEG);
			break;
		}
		case B_FPIXPIC:
		{
 			setFileFormat(FPIX);
			break;
		}
		case B_QUALGOOD:
		{
 			setImageQuality(Q_GOOD);
			break;
		}
		case B_QUALBETTER:
		{
 			setImageQuality(Q_BETTER);
			break;
		}
		case B_QUALBEST:
		{
 			setImageQuality(Q_BEST);
			break;
		}
		case B_DELAYTIMER:
		{
          if (checkBox_L2S18->Value() == 1)
               setShutterDelay(true); 
           else
               setShutterDelay(false); 
           break;
		}
		case B_ERASEALL:
		{
		   BAlert *myAlert = new BAlert("Erase All", "Erase all images on camera ...", "Cancel", "Yes", NULL, B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_WARNING_ALERT); 
   			myAlert->SetShortcut(0, B_ESCAPE); 
      		int32 button_index = myAlert->Go();
			if (button_index == 1)
 				eraseAllImages();
			break;
		}
		case B_SETCAMTIME:
		{
 			setTime();
			break;
		}
		case B_FORMATCARD:
		{
// 			((DC210CameraApp*)be_app)->Camera->formatMemoryCard("WILLY");
			break;
		}
		default:
		{
				BWindow::MessageReceived(message);
			break;
		}
	}
}

status_t cameraprops::updateCameraStatusInfo()
{
	debug("Entering Update Camera Status Info");
	int len = 256;
	unsigned char *buffer = new unsigned char[256];
	int check;
	ComPort->Write("\x7F\x00\x00\x00\x00\x00\x00\x1A",8);
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(B_ERROR);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		receivepacket(buffer,len);
		check = buffer[16];
		if ((check & 15) ==0) zoomposition = Z_58MM;
		else if ((check & 15) == 1) zoomposition = Z_51MM;
		else if ((check & 15) == 2) zoomposition = Z_41MM;
		else if ((check & 15) == 3) zoomposition = Z_34MM;
		else if ((check & 15) == 4) zoomposition = Z_29MM;
		else if ((check & 15) == 5) zoomposition = Z_CLOSEUP;
		check = buffer[19];
		if (check ==1) quality = Q_BEST;
		else if (check == 2) quality = Q_BETTER;
		else if (check == 3) quality = Q_GOOD;
		check = buffer[20];
		if (check ==0) flashsetting = F_AUTO;
		else if (check == 1) flashsetting = F_FILL;
		else if (check == 2) flashsetting = F_OFF;
		else if (check == 3) flashsetting = F_AUTORED;
		else if (check == 4) flashsetting = F_FILLRED;
		check = buffer[22];
		if (check == 0) cameraresolution = LOW_RES;
		else if (check == 1) cameraresolution = HI_RES;
		check = buffer[23];
		if (check == 3) camerafiletype = JPEG;
		else if (check == 4) camerafiletype = FPIX;
		timermode = buffer[29];
		check = buffer[30];
		cardopen = (check >> 3) & 1;
		cardformatted = !((check >> 4) &1);
		cardillegal = (check >> 5) & 1;
		cardwriteprotect = (check >> 6) & 1;
		cardATA = (check >> 7) & 1;
		memcpy(cardid, buffer+77, 11);
		memcpy(cameraid, buffer+90, 32);
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
	if (buffer[0] == 0x00)
		{
			snooze(50000);
			debug("Leaving Update Camera Status Info");
			return(B_NO_ERROR);
			}
		else
			return(B_ERROR);
	}
	else
	return(B_ERROR);
}

void cameraprops::receivepacket(unsigned char *buffer,int& length)
{
		unsigned char inputbuffer[1];
		int check;
		bool failed = false;
		int z=0;
		inputbuffer[0] = 0x01;
		do
		{
			check = 1;
			if (failed == true)
			{
			z++;
			failed = false;
			ComPort->Write("\xe3",1);
			debug("Checksum failed on receive");
			ComPort->Read(inputbuffer,1);
			}
			
			check ^= inputbuffer[0]; 
			for (int i = 0;i<length;i++)
			{
			ComPort->Read(inputbuffer, 1);
			check ^= inputbuffer[0];
			memcpy(buffer+i, inputbuffer,1);
			}
			ComPort->Read(inputbuffer, 1);
			if (inputbuffer[0] != check) 
				failed = true;
		} while (failed);
		ComPort->Write("\xd2",1);
}

int cameraprops::setResolution(resolution res)
{
	unsigned char* buffer = new unsigned char[1];
	if (res == LOW_RES)
	{
		ComPort->Write("\x36\x00\x00\x00\x00\x00\x00\x1A",8);
	}
	else if (res == HI_RES)
	{
		ComPort->Write("\x36\x00\x01\x00\x00\x00\x00\x1A",8);
	}
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::setFileFormat(filetype ftype)
{
	unsigned char* buffer = new unsigned char[1];
	if (ftype == JPEG)
	{
		ComPort->Write("\x37\x00\x03\x00\x00\x00\x00\x1A",8);
	}
	else if (ftype == FPIX)
	{
		ComPort->Write("\x37\x00\x04\x00\x00\x00\x00\x1A",8);
	}
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::setImageQuality(imagequality quality)
{
	unsigned char* buffer = new unsigned char[1];
	if (quality == Q_BEST)
	{
		ComPort->Write("\x71\x00\x01\x00\x00\x00\x00\x1A",8);
	}
	else if (quality == Q_BETTER)
	{
		ComPort->Write("\x71\x00\x02\x00\x00\x00\x00\x1A",8);
	}
	else if (quality == Q_GOOD)
	{
		ComPort->Write("\x71\x00\x03\x00\x00\x00\x00\x1A",8);
	}
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::setFlashMode(flashmode flash)
{
	unsigned char* buffer = new unsigned char[1];
	if (flash == F_AUTO)
	{
		ComPort->Write("\x72\x00\x00\x00\x00\x00\x00\x1A",8);
	}
	else if (flash == F_FILL)
	{
		ComPort->Write("\x72\x00\x01\x00\x00\x00\x00\x1A",8);
	}
	else if (flash == F_OFF)
	{
		ComPort->Write("\x72\x00\x02\x00\x00\x00\x00\x1A",8);
	}
	else if (flash == F_AUTORED)
	{
		ComPort->Write("\x72\x00\x03\x00\x00\x00\x00\x1A",8);
	}
	else if (flash == F_FILLRED)
	{
		ComPort->Write("\x72\x00\x04\x00\x00\x00\x00\x1A",8);
	}
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::setShutterDelay(bool delay)
{
	unsigned char* buffer = new unsigned char[1];
	if (delay)
	{
		ComPort->Write("\x74\x00\x01\x00\x00\x00\x00\x1A",8);
	}
	else
	{
		ComPort->Write("\x74\x00\x00\x00\x00\x00\x00\x1A",8);
	}
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::setZoom(zoommode zoom)
{
	unsigned char* buffer = new unsigned char[1];
	if (zoom == Z_58MM)
	{
		ComPort->Write("\x78\x00\x00\x00\x00\x00\x00\x1A",8);
	}
	else if (zoom == Z_51MM)
	{
		ComPort->Write("\x78\x00\x01\x00\x00\x00\x00\x1A",8);
	}
	else if (zoom == Z_41MM)
	{
		ComPort->Write("\x78\x00\x02\x00\x00\x00\x00\x1A",8);
	}
	else if (zoom == Z_34MM)
	{
		ComPort->Write("\x78\x00\x03\x00\x00\x00\x00\x1A",8);
	}
	else if (zoom == Z_29MM)
	{
		ComPort->Write("\x78\x00\x04\x00\x00\x00\x00\x1A",8);
	}
	else if (zoom == Z_CLOSEUP)
	{
		ComPort->Write("\x78\x00\x05\x00\x00\x00\x00\x1A",8);
	}
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::eraseAllImages()
{
	unsigned char* buffer = new unsigned char[1];
	ComPort->Write("\x7B\x00\xFF\xFF\x00\x00\x00\x1A",8);
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}

int cameraprops::setTime()
{
	unsigned char *buffer = new unsigned char[1];
	char *temp;
	bigtime_t settime= (real_time_clock() - 852076800) * 2;
	ComPort->Write("\x75\x00",2);
	temp = (char*)(settime >> 24);
	ComPort->Write(&temp,1);
	temp = (char*)(settime >> 16);
	ComPort->Write(&temp,1);
	temp = (char*)(settime >> 8);
	ComPort->Write(&temp,1);
	temp = (char*)(settime >> 0);
	ComPort->Write(&temp,1);
	ComPort->Write("\x00\x1A",2);
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(1);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
			{
			snooze(50000);
			return(0);
			}
		else
			return(2);
	}
	else
	return(3);
}


