#include "level2.h"
#include "configplugin.h"
#include "comms.h"
#include <cstdio>

extern BLooper* msgtarget;

status_t setMessageTarget(BLooper* mtarget)
{
	msgtarget = mtarget;
	return(B_NO_ERROR);
}

status_t deletePicture()
{
	haveigotfilenames = false;
	unsigned char *buffer = new unsigned char[1];
	char* temp2;
	ComPort->Write("\x7B\x00", 2);
	temp2 = (char*)(currentpicturenumber >> 8);
	ComPort->Write(&temp2,1);
	temp2 = (char*)(currentpicturenumber >> 0);
	ComPort->Write(&temp2,1);
	ComPort->Write("\x00",1);
	ComPort->Write("\x00\x00\x1A",3);
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(B_ERROR);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
		{
			snooze(50000);
			return(B_NO_ERROR);
		}
		else
			return(B_ERROR);
	}
	else
		return(B_ERROR);
}

status_t takePicture()
{
	haveigotfilenames = false;
	unsigned char* buffer = new unsigned char[1];
	ComPort->Write("\x7C\x00\x00\x00\x00\x00\x00\x1A",8);
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(B_ERROR);
	else if (buffer[0] == 0xd1)
	{
		ComPort->Read(buffer,1);
		while (buffer[0] == 0xf0) 
			ComPort->Read(buffer,1);
		if (buffer[0] == 0x00)
		{
			snooze(50000);
			return(B_NO_ERROR);
		}
		else
			return(B_ERROR);
	}
	else
		return(B_ERROR);
}

BWindow* configurePlugin(BPoint middle)
{
	return(new configplugin(BRect(middle.x - 74,middle.y - 122,
								  middle.x + 74,middle.y + 122 )));
}

status_t getImageName(char* &name)
{
	if (haveigotfilenames == false)
		if (getfiledata() < B_NO_ERROR)
			return(B_ERROR);
	map<int, char*>::iterator pname;
	pname = imagenames.find(currentpicturenumber);
	name = strdup(pname->second);
	return(B_NO_ERROR);
}

status_t getImageSize(int &size)
{
	if (haveigotfilenames == false)
		if (getfiledata() < B_NO_ERROR)
			return(B_ERROR);
	map<int, int>::iterator psize;
	psize = imagesizes.find(currentpicturenumber);
	size = psize->second;
	return(B_NO_ERROR);
}

status_t getImageDate(char* &date)
{
	if (haveigotfilenames == false)
		if (getfiledata() < B_NO_ERROR)
			return(B_ERROR);
	map<int, char*>::iterator pdate;
	pdate = imagedates.find(currentpicturenumber);
	date = pdate->second;
	return(B_NO_ERROR);
}

status_t getfiledata()
{
	imagenames.clear();
	imagesizes.clear();
	imagedates.clear();
	unsigned char *buffer = new unsigned char[256];
	ComPort->Write("\x4A\x00\x00\x00\x00\x00\x00\x1A",8);
	unsigned char* buffer2=NULL;
	int receivelength = 256;
	bool pending = true;
	int count=0;
	int number = 0;
	bool firstpacket = true;
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(B_ERROR);
	else if (buffer[0] == 0xd1)
	{
		do 
		{
			ComPort->Read(buffer,1);
			while (buffer[0] == 0xf0) 
				ComPort->Read(buffer,1);
			if (buffer[0] == 0x01)
			{
				pending = true;
				receivepacket(buffer,receivelength, true);
				if (firstpacket == true)
				{
					number = (256*buffer[0]) + buffer[1];
					buffer2 = new unsigned char[(number*20)+2+receivelength];
					memcpy(buffer2, buffer+2,254);
					firstpacket = false;
				}
				else
				{
					memcpy(buffer2+((count-1)*256)-2, buffer,256);
					firstpacket = false;
				}
			}
			else
				pending = false;
		} while (pending);
		if (buffer[0] == 0x00)
		{
			
			for (int i=0;i < number;i++)
			{
					int date = ((buffer2[((i)*20)+14])<<8) + (buffer2[((i)*20)+15]);
					int time = ((buffer2[((i)*20)+12])<<8) + (buffer2[((i)*20)+13]);
 					uint32 longsize = 0;
 					uint32 year = 1980+((date & 0xFE00) >> 9);
 					uint32 month = (date & 0x01E0) >> 5;
 					uint32 day = date & 0x001F;
 					uint32 hour = (time & 0xF800) >> 11;
 					uint32 minute = (time & 0x07E0) >> 5;
 					uint32 second = time & 0x001F;
 					char* datestring = new char[100];
 					char* yearstring = new char[10];
 					sprintf(yearstring, "%.2i", (int)year);
 					yearstring++;
 					yearstring++;
 					sprintf(datestring, " %.2i:%.2i:%.2i %.2i/%.2i/%s", (int)hour, (int)minute, (int)second, (int)day, (int)month, yearstring);
					longsize = ((buffer2[((i)*20)+16] << 24) + (buffer2[((i)*20)+17] << 16) + (buffer2[((i)*20)+18] << 8) + buffer2[((i)*20)+19]);
					char* filename = new char[13];
					memcpy(filename, buffer2+(((i)*20)), 8);
					filename[8] = '.';
					memcpy(filename+9, buffer2+(((i)*20))+8, 3);
					filename[12] = '\0';
					imagedates.insert(pair<int, char*>(i, datestring));
					imagesizes.insert(pair<int, int>(i, (int)longsize));
					imagenames.insert(pair<int, char*>(i, filename));
			}
			snooze(50000);
			haveigotfilenames = true;
			return(B_NO_ERROR);
		}
		else
			return(B_ERROR);
	}
	else
		return(B_ERROR);
}

status_t getThumbnail(BBitmap* & bitmap)
{

	bitmap = new BBitmap(BRect(0,0,95,71), B_RGB32);
	int receivelength = 1024;
	char* temp2;
	ComPort->Write("\x66\x00", 2);
	temp2 = (char*)(currentpicturenumber >> 8);
	ComPort->Write(&temp2,1);
	temp2 = (char*)(currentpicturenumber >> 0);
	ComPort->Write(&temp2,1);
	ComPort->Write("\x00",1);
	ComPort->Write("\x00\x00\x1A",3);
	unsigned char *buffer = new unsigned char[receivelength];
	unsigned char *buffer2 = new unsigned char[7000];
	unsigned char *cfa = new unsigned char[3456];
	unsigned char *rgb = new unsigned char[20736];
	bool pending = true;
	int z=0;
	ComPort->Read(buffer,1);
	while (buffer[0] == 0xf0) 
		ComPort->Read(buffer,1);
	if (buffer[0] == 0xe2)
		return(B_ERROR);
	else if (buffer[0] == 0xd1)
	{
		do 
		{
			ComPort->Read(buffer,1);
			while (buffer[0] == 0xf0) 
				ComPort->Read(buffer,1);
			if (buffer[0] == 0x01)
			{
				pending = true;
				receivepacket(buffer,receivelength, true);
				memcpy(buffer2+z, buffer,receivelength);
				z+=receivelength;
			}
			else
				pending = false;
		} while (pending);
		if (buffer[0] == 0x00)
		{
	    	memcpy(cfa,buffer2, 3456);
	    	cfa2rgb(cfa, rgb, 96, 72);
			bitmap->SetBits(rgb, 20736, 0, B_RGB32);
			snooze(50000);
			return(B_NO_ERROR);
		}
		else
			return(B_ERROR);
	}
	else
		return(B_ERROR);
}

status_t getLevel3FunctionNames(map<char*, char*> &menunames)
{
	menunames.clear();
	menunames.insert(pair<char*, char*>("Configure Camera Settings", "ConfigureCamera"));
	return(B_NO_ERROR);
}

void cfa2rgb( unsigned char *cfa, unsigned char *rgb, int width, int height ) 
{ 
    unsigned char buf[width][height];  
    unsigned char red[width][height]; 
    unsigned char blu[width][height]; 
    unsigned char gre[width][height]; 
    unsigned char ch;          
    register int i, x, y; 
    static unsigned char gamma[] = { 
        0, 10, 15, 19, 22, 25, 28, 31, 33, 36, 38, 40, 42, 44, 46, 48, 
        50, 52, 54, 55, 57, 59, 60, 62, 64, 65, 67, 68, 70, 71, 72, 74, 
        75, 77, 78, 79, 81, 82, 83, 84, 86, 87, 88, 89, 91, 92, 93, 94, 
        95, 97, 98, 99,100,101,102,103,105,106,107,108,109,110,111,112, 
        113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128, 
        129,130,131,132,133,134,135,135,136,137,138,139,140,141,142,143, 
        144,144,145,146,147,148,149,150,150,151,152,153,154,155,156,156, 
        157,158,159,160,160,161,162,163,164,164,165,166,167,168,168,169, 
        170,171,172,172,173,174,175,175,176,177,178,178,179,180,181,181, 
        182,183,184,184,185,186,187,187,188,189,190,190,191,192,192,193, 
        194,195,195,196,197,197,198,199,199,200,201,202,202,203,204,204, 
        205,206,206,207,208,208,209,210,210,211,212,212,213,214,214,215, 
        216,216,217,218,218,219,220,220,221,222,222,223,224,224,225,226, 
        226,227,227,228,229,229,230,231,231,232,233,233,234,234,235,236, 
        236,237,238,238,239,239,240,241,241,242,242,243,244,244,245,245, 
        246,247,247,248,248,249,250,250,251,251,252,253,253,254,254,255 
    }; 
    for( i = 0, y = 0; y < height; y++ ) 
    { 
        for( x = 0; x < width; x+=2 ) 
        { 
            buf[x  ][y] = cfa[i  ] >> 4; 
            buf[x+1][y] = cfa[i++] & 0x0F; 
        } 
    } 
    for( y = 0; y < height; y += 2 ) 
    { 
        for( x = 0; x < width; x += 2 ) 
        { 
            gre[x  ][y  ] = buf[x  ][y  ]; 
            gre[x+1][y  ] = buf[x  ][y  ]; 
            gre[x  ][y+1] = buf[x+1][y+1]; 
            gre[x+1][y+1] = buf[x+1][y+1]; 
            red[x  ][y  ] = buf[x+1][y  ]; 
            red[x+1][y  ] = buf[x+1][y  ]; 
            red[x  ][y+1] = buf[x+1][y  ]; 
            red[x+1][y+1] = buf[x+1][y  ]; 
            blu[x  ][y  ] = buf[x  ][y+1]; 
            blu[x+1][y  ] = buf[x  ][y+1]; 
            blu[x  ][y+1] = buf[x  ][y+1]; 
            blu[x+1][y+1] = buf[x  ][y+1]; 
        } 
    } 
    for ( y = 2; y < height-2; y += 2 ) 
    { 
        for ( x = 3; x < width-2; x += 2 ) 
        { 
            unsigned char r, rl, rb, rc; 
            r  = buf[x  ][y  ]; 
            rl = buf[x-2][y  ]; 
            rb = buf[x  ][y+2]; 
            rc = buf[x-2][y+2]; 
            red[x-1][y  ] = (r + rl          ) / 2; 
            red[x  ][y+1] = (r      + rb     ) / 2; 
            red[x-1][y+1] = (r + rl + rb + rc) / 4; 
        } 
    } 
    for ( y = 2; y < height-2; y += 2 ) 
    { 
        for ( x = 3; x < width-2; x += 2 ) 
        { 
            unsigned char gl, gr, gt, gb; 
            gl = buf[x-1][y  ]; 
            gr = buf[x+1][y  ]; 
            gt = buf[x  ][y-1]; 
            gb = buf[x  ][y+1]; 
            gre[x][y] = (gl + gr + gt + gb) / 4; 
        } 
    } 
    for ( y = 3; y < height-2; y += 2 ) 
    { 
        for ( x = 2; x < width-2; x += 2 ) 
        { 
            unsigned char gl, gr, gt, gb; 
            gl = buf[x-1][y  ]; 
            gr = buf[x+1][y  ]; 
            gt = buf[x  ][y-1]; 
            gb = buf[x  ][y+1]; 
            gre[x][y] = (gl + gr + gt + gb) / 4; 
        } 
    } 
    for ( y = 3; y < height-2; y += 2 ) 
    { 
        for ( x = 2; x < width-2; x += 2 ) 
        { 
            unsigned char b, br, bt, bc; 
            b  = buf[x  ][y  ]; 
            br = buf[x+2][y  ]; 
            bt = buf[x  ][y-2]; 
            bc = buf[x+2][y-2]; 
            blu[x+1][y  ] = (b + br          ) / 2; 
            blu[x  ][y-1] = (b      + bt     ) / 2; 
            blu[x+1][y-1] = (b + br + bt + bc) / 4; 
        } 
    } 
	i=0;
    for( y = height-1; y >= 0; y-- ) 
    { 
        for( x = 0; x < width; x++ ) 
        { 
            ch = red[x][height-1-y]; 
            rgb[i++] = gamma[ (ch * 16) + ch ]; 
            ch = gre[x][height-1-y]; 
            rgb[i++] = gamma[ (ch * 16) + ch ]; 
            ch = blu[x][height-1-y]; 
            rgb[i++] = gamma[ (ch * 16) + ch ]; 
        } 
    } 
    return; 
} 
